###############################################################################
# Quiz.pm                                                                     #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 2.7.00                                                 #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2017 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by:  The YaBB Development Team                                     #
#               with assistance from the YaBB community.                      #
###############################################################################
# Written by Batchman (orig by Phyrron )                                      #
# Additional development by  Whisper68, Carsten, others)                      #
# Updated for 2.7.00 by D.A.Rorabaugh (Dandello)                              #
###############################################################################
use strict;
use warnings;
use CGI::Carp qw(fatalsToBrowser);
our $VERSION = '2.7.00';

our $quizpmver = 'YaBB 2.7.00 $Revision: 1.0 $';
our ($action);
$action ||= q{};
if ( $action eq 'detailedversion' ) { return 1; }

## YaBB system ##
our (
    $abbr_lang,     $ctmain,   $date,         $defaultimagesdir,
    $enable_ubbc,   $iamadmin, $iamguest,     $imagesdir,
    $memberdir,     $menusep,  $modimgurl,    $scripturl,
    $showyabbcbutt, $uid,      $username,     $vardir,
    $yyinlinestyle, $yymain,   $yynavigation, $yysetlocation,
    $yytitle,       %croak,    %error_txt,    %FORM,
    %img,           %INFO,     %link,         %memberunfo,
    @censored,
);

our (
    $editmain,          $en_quiz,             $myquiz01,
    $myquizadd_01,      $myquizadd_02,        $myquizaddquest_01,
    $myquizanswer,      $myquizdel,           $myquizdisplay_01,
    $myquizdisplay_02,  $myquizdisplay_03,    $myquizdisplay_04a,
    $myquizdisplay_04b, $myquizdisplay_04c,   $myquizdisplay_04d,
    $myquizdisplay_04e, $myquizdisplay_05,    $myquizdisplay_06,
    $myquizdisplay_07,  $myquizdisplay_08,    $myquizdisplay_09,
    $myquizdisplay02,   $myquizmain_01,       $myquizmain_02,
    $myquizmain_03,     $myquizmain_04,       $myQuizmodify_01,
    $myQuizmodify_02,   $myquizresult_01,     $myquizresult_02,
    $myQuiztimelim_01,  $myQuiztimelim_02,    $QuestionTimelimit,
    $QuizAddAllMembers, @QuizAddGroups,       $quizcreatorname,
    @QuizDelGroups,     $QuizHighScoreLength, $QuizMaxDecrpChars,
    $QuizMaxQuestChars, $QuizMaxTimelimit,    $QuizMinQuestions,
    @QuizModGroups,     $QuizSetTimelimit,    $QuizzesPerPage,
    %quiztxt,
);

if ( $iamguest && $en_quiz > 1 ) { fatal_error('members_only'); }

my $QuizBar = "$modimgurl/quiz/QuizBar.gif";
load_language('Post');
load_language('Mods/Quiz');
get_template('Mods/Quiz');

require Sources::DateTime;

if ( !-e "$vardir/Mods/quiz2.txt" ) {
    my $qfile = q~$QuizHighScoreLength = 5;
$QuizzesPerPage = 10;
$QuizMinQuestions = 10;
@QuizAddGroups = ();
@QuizModGroups = ();
@QuizDelGroups = ();
$QuizAddAllMembers = 1;
$QuizModifyAllMembers = 1;
$QuizDeleteAllMembers = 1;
$QuizSetTimelimit = 1;
$QuizMaxTimelimit = 120;
$QuizMaxQuestChars = 500;
$QuizMaxDecrpChars = 500;
$QuizGuestTab = 1;

1;
~;
    our ($FILE);
    fopen( 'FILE', '>>', "$vardir/Mods/quiz2.txt" );
    print {$FILE} $qfile or croak "$croak{'print'} quiz";
    fclose('FILE');
}
$QuizMaxQuestChars ||= 500;
$QuizMaxDecrpChars ||= 500;

sub quizmain {
    require "$vardir/Mods/quiz2.txt";

    $yytitle .= qq~ $quiztxt{'4'} ~;
    $yynavigation = qq~&rsaquo; $quiztxt{'4'}~;
    my $date2 = $date;

    opendir QUIZFILES, "$vardir/Mods";
    my @quizfile = grep { /[.]quiz$/xsm } readdir QUIZFILES;
    closedir QUIZFILES;

    # Create quizlist
    my $membquizcount = 0;
    my @membquiz      = ();
    if ( -e ("$memberdir/$username.quiz") ) {
        our ($FILE);
        fopen( 'FILE', '<', "$memberdir/$username.quiz" );
        @membquiz = <$FILE>;
        fclose('FILE');

        foreach my $i (@membquiz) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }
        $membquizcount = @membquiz;
    }

    my $x       = 0;
    my @tmplist = ();
    for my $quizname (@quizfile) {
        chomp $quizname;
        our ($QUIZFILE);
        fopen( 'QUIZFILE', '<', "$vardir/Mods/$quizname" );
        my @quiz = <$QUIZFILE>;
        fclose('QUIZFILE');
        for my $i (@quiz) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }
        chomp @quiz;
        $quizname =~ s/[.]quiz$//gxsm;
        my $quiztitle              = $quiz[0];
        my $quizimage              = $quiz[1];
        my $quizcreatorname        = $quiz[2];
        my $quizcreatordisplayname = $quiz[3];
        my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

        my $solvestate = 0;

        for my $i ( 0 .. ( $membquizcount - 1 ) ) {
            my ( $tmp_quizname, $tmp_quizposition, $tmp_quizpoints ) =
              split /[|]/xsm, $membquiz[$i];
            if ( $tmp_quizname eq $quizname ) {
                if ( $tmp_quizposition == $quizquestionnumber ) {
                    $solvestate = 2;
                }
                else {
                    $solvestate = 1;
                }
            }
        }

        load_user($quizcreatorname);
        my $quizprofile = q{};
        {
            no strict qw(refs);
            if ( ${ $uid . $quizcreatorname }{'realname'} ) {
                $quizprofile = $link{$quizcreatorname};
            }
            else {
                $quizprofile = $quizcreatordisplayname;
            }
        }
        my $quizdescription = $quiz[4];
        my $quiztimes       = $quiz[5];
        my $quizaverage     = $quiz[6];
        my $quizdifficulty  = 0.1 * int( ( 100 - $quiz[6] ) * 0.5 );
        if ( $quiztimes == 0 ) { $quizdifficulty = q{-}; }
        if ( $quiz[8] =~
            m/(\d{2})\/(\d{2})\/(\d{2,4}).*?(\d{2})\:(\d{2})\:(\d{2})/ism )
        {
            $quiz[8] = stringtotime( $quiz[8] );
        }
        my $date1 = $quiz[8];
        my $days_reg = calcdtdiff( $date1, $date2 );

        # $days_reg = $result;
        if (   ( $quizquestionnumber >= $QuizMinQuestions && $ispublic )
            || $quizcreatorname eq $username
            || $iamadmin )
        {
            $tmplist[$x] =
qq~$quizname|$quiztitle|$quizimage|$quizcreatorname|$quizcreatordisplayname|$quizprofile|$quizdescription|$quiztimes|$quizdifficulty|$quizquestionnumber|$date1|$days_reg|$solvestate|$ispublic~;
            $x++;
        }
    }

    my $quizcount = @tmplist;

    my $heading = q{};
    my (
        $sortmode, $sortorder, $selName, $selCrea,
        $selDiff,  $selNumb,   $selTime, $selDate
    );
    my ( $order_name, $order_creator, $order_difficulty, $order_num,
        $order_times, $order_date, $bb );
    my $startmode = q{};
    my @sortlist  = ();
    my $pageindex = q{};
    if ( !$quizcount ) {
        $heading = $quiztxt{'89'};
    }
    else {
        $sortmode  = $INFO{'sort'};
        $sortorder = $INFO{'order'};

        $selName = q~ class="windowbg2"~;
        $selCrea = q~ class="windowbg2"~;
        $selDiff = q~ class="windowbg2"~;
        $selNumb = q~ class="windowbg2"~;
        $selTime = q~ class="windowbg2"~;
        $selDate = q~ class="windowbg2"~;

        if ( $sortmode && $sortmode eq 'name' ) {
            @sortlist =
              map  { $_->[0] }
              sort { uc( $a->[2] ) cmp uc( $b->[2] ) }
              map  { [ $_, ( split /[|]/xsm )[ 0 .. 2 ] ] } (@tmplist);
            $selName = q~ class="windowbg"~;
        }
        elsif ( $sortmode && $sortmode eq 'creator' ) {
            @sortlist = map { $_->[0] } sort {
                     uc( $b->[4] ) cmp uc( $a->[4] )
                  || uc( $a->[2] ) cmp uc( $b->[2] )
            } map { [ $_, ( split /[|]/xsm )[ 0 .. 4 ] ] } (@tmplist);
            $selCrea = q~ class="windowbg"~;
        }
        elsif ( $sortmode && $sortmode eq 'difficulty' ) {
            @sortlist = map { $_->[0] } sort {
                ( $b->[9] ) <=> ( $a->[9] )
                  || uc( $a->[2] ) cmp uc( $b->[2] )
            } map { [ $_, ( split /[|]/xsm )[ 0 .. 9 ] ] } (@tmplist);
            $selDiff = q~ class="windowbg"~;
        }
        elsif ( $sortmode && $sortmode eq 'num' ) {
            @sortlist = map { $_->[0] } sort {
                ( $b->[10] ) <=> ( $a->[10] )
                  || uc( $a->[2] ) cmp uc( $b->[2] )
            } map { [ $_, ( split /[|]/xsm )[ 0 .. 10 ] ] } (@tmplist);
            $selNumb = q~ class="windowbg"~;
        }
        elsif ( $sortmode && $sortmode eq 'times' ) {
            @sortlist = map { $_->[0] } sort {
                ( $b->[8] ) <=> ( $a->[8] )
                  || uc( $a->[2] ) cmp uc( $b->[2] )
            } map { [ $_, ( split /[|]/xsm )[ 0 .. 8 ] ] } (@tmplist);
            $selTime = q~ class="windowbg"~;
        }
        elsif ( $sortmode && $sortmode eq 'date' ) {
            @sortlist = map { $_->[0] } sort {
                ( $a->[11] ) <=> ( $b->[11] )
                  || uc( $a->[2] ) cmp uc( $b->[2] )
            } map { [ $_, ( split /[|]/xsm )[ 0 .. 11 ] ] } (@tmplist);
            $selDate = q~ class="windowbg"~;
        }
        else {
            @sortlist =
              map  { $_->[0] }
              sort { uc( $a->[2] ) cmp uc( $b->[2] ) }
              map  { [ $_, ( split /[|]/xsm )[ 0 .. 2 ] ] } (@tmplist);
            $selName = q~ class="windowbg"~;
        }

        if ( $INFO{'order'} && $INFO{'order'} eq 'reverse' ) {
            @sortlist = reverse @sortlist;
        }
        else {
            if ( $sortmode && $sortmode eq 'name' ) {
                $order_name = ';order=reverse';
            }
            elsif ( $sortmode && $sortmode eq 'creator' ) {
                $order_creator = ';order=reverse';
            }
            elsif ( $sortmode && $sortmode eq 'difficulty' ) {
                $order_difficulty = ';order=reverse';
            }
            elsif ( $sortmode && $sortmode eq 'num' ) {
                $order_num = ';order=reverse';
            }
            elsif ( $sortmode && $sortmode eq 'times' ) {
                $order_times = ';order=reverse';
            }
            elsif ( $sortmode && $sortmode eq 'date' ) {
                $order_date = ';order=reverse';
            }
        }

        if ($sortmode) {
            $sortmode = ';sort=' . $INFO{'sort'};
        }
        if ($sortorder) {
            $sortorder = ';order=' . $INFO{'order'};
        }

        # Construct the page links for this board.
        my $start = 0;
        if   ( !$INFO{'start'} ) { $start = 0; }
        else                     { $start = "$INFO{'start'}"; }
        my $numbegin = ( $start + 1 );
        my $numend   = ( $start + $QuizzesPerPage );
        if ( $numend > $quizcount ) { $numend = $quizcount; }
        $bb = $start;

        my $indexdisplaynum = 3;    # max number of pages to display
        my $startpage       = 0;
        my $tmpa            = 1;
        my $tmpx = int( $quizcount / $QuizzesPerPage );
        if ( $start >= ( ( $indexdisplaynum - 1 ) * $QuizzesPerPage ) ) {
            $startpage =
              $start - ( ( $indexdisplaynum - 1 ) * $QuizzesPerPage );
            $tmpa = int( $startpage / $QuizzesPerPage ) + 1;
        }
        my $endpage = $quizcount;
        if ( $quizcount >= $start + ( $indexdisplaynum * $QuizzesPerPage ) ) {
            $endpage = $start + ( $indexdisplaynum * $QuizzesPerPage );
        }
        else { $endpage = $quizcount }
        if ( $startpage > 0 ) {
            $pageindex =
qq~<a href="$scripturl?action=$action;start=0$sortmode$sortorder">1</a>&nbsp;...&nbsp;~;
        }
        if ( $startpage == $QuizzesPerPage ) {
            $pageindex =
qq~<a href="$scripturl?action=$action;start=0$sortmode$sortorder">1</a>&nbsp;~;
        }
        for my $counter ( $startpage .. ( $endpage - 1 ) ) {
            if ( $counter % $QuizzesPerPage == 0 ) {
                $pageindex .=
                  $start == $counter && $start ne 'all'
                  ? qq~$tmpa ~
                  : qq~<a href="$scripturl?action=$action;start=$counter$sortmode$sortorder">$tmpa</a> ~;
                ++$tmpa;
            }
        }
        $tmpx = $quizcount - 1 - $QuizzesPerPage;
        my $outerpn      = int( $tmpx / $QuizzesPerPage );
        my $lastpn       = int( ( $quizcount - 1 ) / $QuizzesPerPage ) + 1;
        my $lastptn      = ( $lastpn - 1 ) * $QuizzesPerPage;
        my $pageindexadd = q{};
        if ( $endpage < $quizcount - $QuizzesPerPage ) {
            $pageindexadd = q~...&nbsp;~;
        }
        if ( $endpage != $quizcount ) {
            $pageindexadd .=
qq~<a href="$scripturl?action=$action;start=$lastptn$sortmode$sortorder">$lastpn</a>&nbsp;~;
        }
        $pageindex .= $pageindexadd;
        if ( $start eq 'all' ) {
            $pageindex .= qq~$quiztxt{'190'}~;
            my $QuizzesPerPage = $quizcount;
            $startmode = q~;start=all~;
            $heading   = qq~$quiztxt{'3'} $quizcount $quiztxt{'4'}~;
        }
        else {
            $sortmode  ||= q{};
            $sortorder ||= q{};
            $pageindex .=
qq~<a href="$scripturl?action=$action;start=all$sortmode$sortorder">$quiztxt{'86'}</a>~;
            $heading =
qq~$quiztxt{'5'} $numbegin $quiztxt{'88'} $numend ($quiztxt{'87'} $quizcount $quiztxt{'6'})~;
        }
    }

    my $imgnewquiz = qq~<a href="$scripturl?action=quizadd">$quiztxt{'2'}</a>~;

    my $access = quizaccesscheck('add');

    my $myaccess = q{};
    if ($access) {
        $myaccess = qq~
            <td class="windowbg2 center">$imgnewquiz</td>
~;
    }
    $yymain .= $myquizmain_01;

    my $quizcnt = q{};
    if ($quizcount) {
        $order_name       ||= q{};
        $order_creator    ||= q{};
        $order_difficulty ||= q{};
        $order_num        ||= q{};
        $order_times      ||= q{};
        $order_date       ||= q{};
        $quizcnt .= $myquizmain_02;
        $quizcnt =~ s/\Q{yabb order_name}\E/$order_name/gxsm;
        $quizcnt =~ s/\Q{yabb order_creator}\E/$order_creator/gxsm;
        $quizcnt =~ s/\Q{yabb order_difficulty}\E/$order_difficulty/gxsm;
        $quizcnt =~ s/\Q{yabb order_num}\E/$order_num/gxsm;
        $quizcnt =~ s/\Q{yabb order_times}\E/$order_times/gxsm;
        $quizcnt =~ s/\Q{yabb order_date}\E/$order_date/gxsm;
        $quizcnt =~ s/\Q{yabb startmode}\E/$startmode/gxsm;
        $quizcnt =~ s/\Q{yabb selName}\E/$selName/gxsm;
        $quizcnt =~ s/\Q{yabb selCrea}\E/$selCrea/gxsm;
        $quizcnt =~ s/\Q{yabb selDiff}\E/$selDiff/gxsm;
        $quizcnt =~ s/\Q{yabb selNumb}\E/$selNumb/gxsm;
        $quizcnt =~ s/\Q{yabb selTime}\E/$selTime/gxsm;
        $quizcnt =~ s/\Q{yabb selDate}\E/$selDate/gxsm;

        my $numshown = 0;
        while ( $numshown < $QuizzesPerPage ) {
            $numshown++;
            my (
                $quizname,               $quiztitle,
                $quizimage,              $quizcreatorname,
                $quizcreatordisplayname, $quizprofile,
                $quizdescription,        $quiztimes,
                $quizdifficulty,         $quizquestionnumber,
                $quizposted,             $days_reg,
                $solvestate,             $ispublic
            ) = split /[|]/xsm, $sortlist[$bb] || q{};
            $quizposted = timeformat($quizposted);

            if ( !$quizname ) { next; }
            my $mysolvestate = q{};
            if ( $solvestate == 2 ) {
                $mysolvestate =
qq~<img src="$modimgurl/quiz/chekgreen.gif" alt="$quiztxt{'70'}" />~;
            }
            elsif ( $solvestate == 1 ) {
                $mysolvestate =
qq~<img src="$modimgurl/quiz/chekyellow.gif" alt="$quiztxt{'71'}" />~;
            }
            if (   ( $quizcreatorname eq $username || $iamadmin )
                && ( $quizquestionnumber < $QuizMinQuestions || !$ispublic ) )
            {
                $mysolvestate =
                  qq~<img src="$imagesdir/red1.gif" alt="$quiztxt{'30'}" />~;
            }
            if (   $quizcreatorname eq $username
                && $quizquestionnumber >= $QuizMinQuestions
                && $ispublic )
            {
                $mysolvestate =
                  qq~<img src="$imagesdir/green1.gif" alt="$quiztxt{'90'}" />~;
            }
            $quizcnt .= $myquizmain_03;
            $quizcnt =~ s/\Q{yabb mysolvestate}\E/$mysolvestate/gxsm;
            $quizcnt =~ s/\Q{yabb quizname}\E/$quizname/gxsm;
            $quizcnt =~ s/\Q{yabb quiztitle}\E/$quiztitle/gxsm;
            $quizcnt =~ s/\Q{yabb quizprofile}\E/$quizprofile/gxsm;
            $quizcnt =~ s/\Q{yabb quizdifficulty}\E/$quizdifficulty/gxsm;
            $quizcnt =~
              s/\Q{yabb quizquestionnumber}\E/$quizquestionnumber/gxsm;
            $quizcnt =~ s/\Q{yabb quiztimes}\E/$quiztimes/gxsm;
            $quizcnt =~ s/\Q{yabb quizposted}\E/$quizposted/gxsm;
            $bb++;
        }
        $yymain .= $myquizmain_04;
    }
    $yymain =~ s/\Q{yabb heading}\E/$heading/gxsm;
    $yymain =~ s/\Q{yabb myaccess}\E/$myaccess/gxsm;
    $yymain =~ s/\Q{yabb pageindex}\E/$pageindex/gxsm;
    $yymain =~ s/\Q{yabb quizcnt}\E/$quizcnt/gxsm;

    template();
    exit;
}

sub quizdisplay {

    require "$vardir/Mods/quiz2.txt";

    my $quizname = $INFO{'name'};
    my $date2    = $date;
    if ( -e "$vardir/Mods/$quizname.quiz" ) {
        our ($QUIZFILE);
        fopen( 'QUIZFILE', '<', "$vardir/Mods/$quizname.quiz" );
        my @quiz = <$QUIZFILE>;
        fclose('QUIZFILE');

        for my $i (@quiz) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }

        my $quizimage              = $quiz[1];
        my $quizcreatordisplayname = $quiz[3];
        my $quizcreatorname        = $quiz[2];
        my $quizdescription        = $quiz[4];
        my $quizdifficulty         = 0.1 * int( ( 100 - $quiz[6] ) * 0.5 );

        if ( $quiz[5] == 0 ) { $quizdifficulty = q{-} }

        my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

        my $ispubcheck = q{};
        if ($ispublic) {
            $ispubcheck = q~checked="checked"~;
        }

        # no html code in description
        $quizdescription = clean1($quizdescription);

        # censor quiz description
        load_censor_list();
        for (@censored) {
            my ( $tmpa, $tmpb ) = @{$_};
            $quizdescription =~ s/\Q$tmpa\E/$tmpb/gism;
        }

        # do YaBBC  on the quiz description
        if ($enable_ubbc) {
            enable_yabbc();
            $quizdescription =
              do_ubbc( $quizdescription, q{}, $quizcreatorname );
        }

        load_user($quizcreatorname);
        my $quizprofile = $quizcreatordisplayname;
        {
            no strict qw(refs);
            if ( ${ $uid . $quizcreatorname }{'realname'} ) {
                $quizprofile = $link{$quizcreatorname};
            }
            else {
                $quizprofile = $quizcreatordisplayname;
            }
        }

        if ( $quiz[8] =~
            m/(\d{2})\/(\d{2})\/(\d{2,4}).*?(\d{2})\:(\d{2})\:(\d{2})/ism )
        {
            $quiz[8] = stringtotime( $quiz[8] );
        }

        my $quizposted = timeformat( $quiz[8] );

        my $questionnumber = 1;

        if ( -e ("$memberdir/$username.quiz") ) {
            our ($FILE);
            fopen( 'FILE', '<', "$memberdir/$username.quiz" );
            my @membquiz = <$FILE>;
            fclose('FILE');

            for my $i (@membquiz) {
                $i =~ tr/\r//d;
                $i =~ tr/\n//d;
            }

            my $membquizcount = @membquiz;
            my @quest_open    = ();
            for my $i ( 0 .. ( $membquizcount - 1 ) ) {
                $quest_open[$i] = 'disabled';
                my ( $tmp_quizname, $tmp_quizposition, $tmp_quizpoints ) =
                  split /[|]/xsm, $membquiz[$i];
                if ( $tmp_quizname eq $quizname ) {
                    $questionnumber = $tmp_quizposition;
                    $questionnumber++;
                }
            }
        }

        $yytitle .= qq~ $quiz[0] ~;

        $yynavigation =
qq~&rsaquo; <a href="$scripturl?action=quiz" class="nav">$quiztxt{'4'}</a> &rsaquo; $quiz[0]~;

        my $imgquestionadd =
qq~<a href="$scripturl?action=quizquestionadd;name=$quizname">$img{'imgquestionadd'}</a>~;
        my $imgquizmake =
qq~<a href="$scripturl?action=quizquestion;name=$quizname">$img{'imgquizmake'}</a>~;
        my $imgmodify =
qq~<a href="$scripturl?action=quizmodify;name=$quizname">$img{'imgmodify'}</a>~;
        my $imgremovequiz =
qq~<span style="cursor: pointer;" onclick="if (confirm('$quiztxt{'32'} $quiz[0]')) location.href = '$scripturl?action=quizdelete;name=$quizname;q=1'">$img{'imgremovequiz'}</span>~;
        my $imgquizhome =
          qq~<a href="$scripturl?action=quiz">$img{'imgquizhome'}</a>~;

        if ( ( $username eq $quizcreatorname || $iamadmin )
            && $quizquestionnumber > 0 )
        {

            my $myquizdisplay02 = $myquizdisplay_02;
            my $myquizdisplay03 = q{};
            my $x               = 9;
            my $z               = 1;
            for my $i ( 0 .. ( $quizquestionnumber - 1 ) ) {
                my ( $thisquest, undef ) = split /[|]/xsm, $quiz[$x], 2;

                if ($enable_ubbc) {
                    enable_yabbc();
                    $thisquest = do_ubbc( $thisquest, q{}, $quizcreatorname );
                }
                $myquizdisplay03 .= $myquizdisplay_03;
                $myquizdisplay03 =~ s/\Q{yabb z}\E/$z/gxsm;
                $myquizdisplay03 =~ s/\Q{yabb thisquest}\E/$thisquest/gxsm;
                $x++;
                $z++;
            }
            $myquizdisplay02 =~
              s/\Q{yabb myquizdisplay03}\E/$myquizdisplay03/gxsm;
        }

        my $myquizshow = q{};
        if ($iamguest) {
            $myquizshow .= $myquizdisplay_04a;
        }
        elsif ($username ne $quizcreatorname
            && $questionnumber == 1
            && $ispublic )
        {
            $myquizshow .= $myquizdisplay_04b;
            $myquizshow =~ s/\Q{yabb imgquizmake}\E/$imgquizmake/gxsm;
        }
        elsif ($username ne $quizcreatorname
            && $questionnumber <= $quizquestionnumber
            && $ispublic )
        {
            $myquizshow .= $myquizdisplay_04c;
            $myquizshow =~ s/\Q{yabb quizname}\E/$quizname/gxsm;
        }
        elsif ( $quizcreatorname ne $username && $ispublic ) {
            $myquizshow .= $myquizdisplay_04d;
        }
        elsif ($quizcreatorname eq $username
            && $quizquestionnumber < $QuizMinQuestions )
        {
            $myquizshow .= $myquizdisplay_04e;
            $myquizshow =~ s/\Q{yabb QuizMinQuestions}\E/$QuizMinQuestions/gxsm;
        }
        elsif ( ( $quizcreatorname eq $username || $iamadmin )
            && $quizquestionnumber >= $QuizMinQuestions )
        {
            my $releaseinfo = $quiztxt{'100'};
            if ( !$ispublic ) {
                $releaseinfo = $quiztxt{'99'};
            }

            $myquizshow .= $myquizdisplay_05;
            $myquizshow =~ s/\Q{yabb releaseinfo}\E/$releaseinfo/gxsm;
            $myquizshow =~ s/\Q{yabb quizname}\E/$quizname/gxsm;
            $myquizshow =~ s/\Q{yabb ispubcheck}\E/$ispubcheck/gxsm;
        }
        my $qzaccess = q{};
        my $access_1 = quizaccesscheck('add');
        if (   $access_1
            && ( $iamadmin || $username eq $quizcreatorname )
            && !$ispublic )
        {
            $qzaccess .= qq~ $imgquestionadd $menusep ~;
        }
        my $access_2 = quizaccesscheck('mod');
        if ( $access_2 && !$ispublic ) {
            $qzaccess .= qq~ $imgmodify $menusep ~;
        }
        my $access_3 = quizaccesscheck('del');
        if ($access_3) {
            $qzaccess .= qq~ $imgremovequiz $menusep ~;
        }
        require Sources::ContextHelp;

        $yymain .= $myquizdisplay_01;
        $myquizdisplay02 ||= q{};
        $yymain =~ s/\Q{yabb quiz0}\E/$quiz[0]/gxsm;
        $yymain =~ s/\Q{yabb quiz1}\E/$quiz[1]/gxsm;
        $yymain =~ s/\Q{yabb quizdescription}\E/$quizdescription/gxsm;
        $yymain =~ s/\Q{yabb myquizdisplay02}\E/$myquizdisplay02/gxsm;
        $yymain =~ s/\Q{yabb myquizshow}\E/$myquizshow/gxsm;
        $yymain =~ s/\Q{yabb qzaccess}\E/$qzaccess/gxsm;
        $yymain =~ s/\Q{yabb imgquizhome}\E/$imgquizhome/gxsm;
        $yymain =~ s/\Q{yabb quizprofile}\E/$quizprofile/gxsm;
        $yymain =~ s/\Q{yabb quizposted}\E/$quizposted/gxsm;
        $yymain =~ s/\Q{yabb quizquestionnumber}\E/$quizquestionnumber/gxsm;
        $yymain =~ s/\Q{yabb quiz5}\E/$quiz[5]/gxsm;
        $yymain =~ s/\Q{yabb quizdifficulty}\E/$quizdifficulty/gxsm;

        # Load Quiz Highscore
        my @quizscorelist = ();
        our ($FILE);
        if ( -e "$vardir/Mods/$quizname.quizresult" ) {
            fopen( 'FILE', '<', "$vardir/Mods/$quizname.quizresult" );
            @quizscorelist = <$FILE>;
            fclose('FILE');
        }
        chomp @quizscorelist;
        my $quizscores       = @quizscorelist;
        my $i                = 0;
        my $x                = 0;
        my @tmpquizscorelist = ();
        while ( $i < $quizscores ) {
            my ( $tmp_username, $tmp_score, $tmp_date ) = split /[|]/xsm,
              $quizscorelist[$i];
            chomp $tmp_date;
            if ( !$tmp_date ) { $i++; next; }

            if ( $tmp_date =~
                m/(\d{2})\/(\d{2})\/(\d{2,4}).*?(\d{2})\:(\d{2})\:(\d{2})/ism )
            {
                $tmp_date = stringtotime($tmp_date);
            }

            my $date1 = $tmp_date;
            my $days_reg = calcdtdiff( $date1, $date2 );

            #$days_reg = $result;
            $tmpquizscorelist[$x] =
              qq~$tmp_username|$tmp_score|$tmp_date|$days_reg~;
            $x++;
            $i++;
        }

        $quizscores = @tmpquizscorelist;

        # Sort quizscorelist by highscore

        my @sortscorelist =
          map { $_->[0] }
          sort {
            ( $b->[2] ) <=> ( $a->[2] )
              || uc( $a->[0] ) cmp uc( $b->[0] )
          }
          map { [ $_, ( split /[|]/xsm )[ 0 .. 2 ] ] } (@tmpquizscorelist);

        my $highscorelength = $QuizHighScoreLength;

        if ( $INFO{'sort'} && $INFO{'sort'} eq 'high' ) {
            $highscorelength = $quizscores;
        }
        if ( $highscorelength > $quizscores ) {
            $highscorelength = $quizscores;
        }
        if ( $INFO{'sort'} && $INFO{'sort'} eq 'latest' ) {
            $highscorelength = 0;
        }

        if ( $highscorelength > 0 ) {
            my $quizhi = q{};
            for my $i ( 0 .. ( $highscorelength - 1 ) ) {
                my ( $tmp_username, $highscore, $tmp_date, $days_reg ) =
                  split /[|]/xsm, $sortscorelist[$i];
                $tmp_date = timeformat($tmp_date);

                load_user($tmp_username);
                my $tmp_userprofile = qq~$link{$tmp_username}~;
                $quizhi .= $myquizdisplay_07;
                $quizhi =~ s/\Q{yabb tmp_userprofile}\E/$tmp_userprofile/gxsm;
                $quizhi =~ s/\Q{yabb highscore}\E/$highscore/gxsm;
                $quizhi =~ s/\Q{yabb tmp_date}\E/$tmp_date/gxsm;
            }

            if ( $highscorelength < $quizscores ) {
                $quizhi .= $myquizdisplay_08;
                $quizhi =~ s/\Q{yabb quizname}\E/$quizname/gxsm;
            }
            $yymain .= $myquizdisplay_06;
            $yymain =~ s/\Q{yabb quizhi}\E/$quizhi/gxsm;
        }

        # Sort quizscorelist by date
        @sortscorelist =
          map { $_->[0] }
          sort {
            ( $a->[4] ) <=> ( $b->[4] )
              || uc( $a->[0] ) cmp uc( $b->[0] )
          }
          map { [ $_, ( split /[|]/xsm )[ 0 .. 4 ] ] } (@tmpquizscorelist);

        $highscorelength = $QuizHighScoreLength;

        if ( $INFO{'sort'} && $INFO{'sort'} eq 'latest' ) {
            $highscorelength = $quizscores;
        }
        if ( $highscorelength > $quizscores ) {
            $highscorelength = $quizscores;
        }
        if ( $INFO{'sort'} && $INFO{'sort'} eq 'high' ) {
            $highscorelength = 0;
        }

        if ( $highscorelength > 0 ) {
            my $quizhi2 = q{};
            for my $i ( 0 .. ( $highscorelength - 1 ) ) {
                my ( $tmp_username, $highscore, $tmpdate, $reg_days ) =
                  split /[|]/xsm, $sortscorelist[$i];
                $tmpdate = timeformat($tmpdate);

                load_user($tmp_username);
                my $tmp_userprofile = $link{$tmp_username};
                $quizhi2 .= $myquizdisplay_07;
                $quizhi2 =~ s/\Q{yabb tmp_userprofile}\E/$tmp_userprofile/gxsm;
                $quizhi2 =~ s/\Q{yabb highscore}\E/$highscore/gxsm;
                $quizhi2 =~ s/\Q{yabb tmp_date}\E/$tmpdate/gxsm;
            }

            if ( $highscorelength < $quizscores ) {
                $quizhi2 .= $myquizdisplay_08;
                $quizhi2 =~ s/\Q{yabb quizname}\E/$quizname/gxsm;
            }
            $yymain .= $myquizdisplay_09;
            $yymain =~ s/\Q{yabb quizhi2}\E/$quizhi2/gxsm;
        }
    }
    else { $yymain .= '<p>No quiz</p>' }

    template();
    exit;
}

sub quizrelease {

    my $quizname = $FORM{'quizname'};
    our ($QUIZFILE);
    fopen( 'QUIZFILE', '<', "$vardir/Mods/$quizname.quiz" );
    my @quiz = <$QUIZFILE>;
    fclose('QUIZFILE');
    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }
    chomp @quiz;
    my $quiztitle       = $quiz[0];
    my $quizcreatorname = $quiz[2];
    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    if ( $quizcreatorname ne $username && !$iamadmin ) {
        fatal_error('quiz_norelease');
    }

    if (   ( !$FORM{'QuizRelease'} && !$ispublic )
        || ( $FORM{'QuizRelease'} && $ispublic ) )
    {
        write_log();
        $yysetlocation = qq~$scripturl?action=quizdisplay;name=$quizname~;
        redirectexit();
    }
    elsif ( $FORM{'QuizRelease'} ) {
        $ispublic = 1;
        $quiz[7] = qq~$quizquestionnumber|$ispublic~;
    }
    elsif ( !$FORM{'QuizRelease'} ) {
        $ispublic = 0;
        $quiz[7]  = qq~$quizquestionnumber|$ispublic~;
        $quiz[5]  = 0;
        $quiz[6]  = 0;

        our ($RESFILE);
        fopen( 'RESFILE', '<', "$vardir/Mods/$quizname.quizresult" );
        my @quizres = <$RESFILE>;
        fclose('RESFILE');
        for my $i (@quizres) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }
        chomp @quizres;

        for my $restring (@quizres) {
            my ( $tmpusername, undef ) = split /[|]/xsm, $restring, 2;

            our ($FILE);
            fopen( 'FILE', '<', "$memberdir/$tmpusername.quiz" );
            my @membquiz = <$FILE>;
            fclose('FILE');
            for my $i (@membquiz) {
                $i =~ tr/\r//d;
                $i =~ tr/\n//d;
            }
            chomp @membquiz;

            my $i = 0;
            fopen( 'FILE', '>', "$memberdir/$tmpusername.quiz" );
            for my $memstring (@membquiz) {
                my ( $tmpquizname, undef ) = split /[|]/xsm, $memstring, 2;
                if ( $tmpquizname ne $quizname ) {
                    print {$FILE} "$membquiz[$i]\n"
                      or croak "$croak{'print'} FILE";
                }
                $i++;
            }
            fclose('FILE');

            fopen( 'FILE', '<', "$memberdir/$tmpusername.quizlog" );
            my @memblquiz = <$FILE>;
            fclose('FILE');
            for my $i (@memblquiz) {
                $i =~ tr/\r//d;
                $i =~ tr/\n//d;
            }
            chomp @memblquiz;

            $i = 0;
            fopen( 'FILE', '>', "$memberdir/$tmpusername.quizlog" );
            for my $memlstring (@memblquiz) {
                my ( $tmpquizlname, undef ) = split /[|]/xsm, $memlstring, 2;
                if ( $tmpquizlname ne $quizname ) {
                    print {$FILE} "$memblquiz[$i]\n"
                      or croak "$croak{'print'} FILE";
                }
                $i++;
            }
            fclose('FILE');

            if ( !-s "$memberdir/$tmpusername.quiz" ) {
                unlink "$memberdir/$tmpusername.quiz";
            }
            if ( !-s "$memberdir/$tmpusername.quizlog" ) {
                unlink "$memberdir/$tmpusername.quizlog";
            }
        }

        unlink "$vardir/Mods/$quizname.quizresult";
    }

    our ($FILE);
    fopen( 'FILE', '>', "$vardir/Mods/$quizname.quiz" );
    my $quizcount = @quiz;
    for my $i ( 0 .. ( $quizcount - 1 ) ) {
        print {$FILE} "$quiz[$i]\n" or croak "$croak{'print'} FILE";
    }
    fclose('FILE');

    write_log();
    $yysetlocation = qq~$scripturl?action=quiz~;
    redirectexit();
    return;
}

sub quizdelete {

    my $quizname = $INFO{'name'};
    our ($QUIZFILE);
    fopen( 'QUIZFILE', '<', "$vardir/Mods/$quizname.quiz" );
    my @quiz = <$QUIZFILE>;
    fclose('QUIZFILE');
    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }
    chomp @quiz;
    my $quiztitle       = $quiz[0];
    my $quizcreatorname = $quiz[2];

    my $access = quizaccesscheck('del');

    if ( !$access ) {
        fatal_error('quiz_nodelete');
    }

    if ( $INFO{'q'} eq '1' ) {
        unlink "$vardir/Mods/$quizname.quiz";
        unlink "$vardir/Mods/$quizname.quizresult";

        write_log();
        $yysetlocation = qq~$scripturl?action=quiz~;
        redirectexit();
    }
    elsif ( $INFO{'q'} eq '0' ) {
        write_log();
        $yysetlocation = qq~$scripturl?action=quizdisplay;name=$quizname~;
        redirectexit();
    }
    else {
        $yytitle .= qq~ $quiztxt{'1'} ~;
        $yymain  .= $myquizdel;
        $yymain =~ s/\Q{yabb quiztitle}\E/$quiztitle/gxsm;
        $yymain =~ s/\Q{yabb quizname}\E/$quizname/gxsm;
        template();
        exit;
    }
}

sub quizadd {
    require "$vardir/Mods/quiz2.txt";

    my $access = quizaccesscheck('add');

    if ($iamguest) {
        fatal_error('quiz_noadd_login');
    }

    if ( !$access ) {
        fatal_error('quiz_noadd');
    }

    $yytitle .= qq~ $quiztxt{'2'} ~;

    $yynavigation =
qq~&rsaquo; <a href="$scripturl?action=quiz" class="nav">$quiztxt{'4'}</a> &rsaquo; $quiztxt{'2'}~;

    my $date1      = $date;
    my $quizposted = timeformat($date1);

    my $showubbc = q{};
    if ( $enable_ubbc && $showyabbcbutt ) {
        drawEditor($QuizMaxDecrpChars);
        $showubbc = $myquizadd_02;
        $showubbc =~ s/\Q{yabb editmain}\E/$editmain/gxsm;
    }
    $yymain .= $myquizadd_01;
    $yymain =~ s/\Q{yabb username}\E/$username/gxsm;
    {
        no strict qw(refs);
        $yymain =~ s/\Q{yabb displayname}\E/${$uid.$username}{'realname'}/gxsm;
    }
    $yymain =~ s/\Q{yabb date1}\E/$date1/gxsm;
    $yymain =~ s/\Q{yabb quizposted}\E/$quizposted/gxsm;
    $yymain =~ s/\Q{yabb quizposted}\E/$quizposted/gxsm;
    $yymain =~ s/\Q{yabb showubbc}\E/$showubbc/gxsm;
    template();
    exit;
}

sub quizadd2 {
    require "$vardir/Mods/quiz2.txt";
    my $access = quizaccesscheck('add');

    if ($iamguest) {
        fatal_error('quiz_noadd_login');
    }

    if ( !$access ) {
        fatal_error('quiz_noadd');
    }

    my $filename        = $FORM{'name'};
    my $title           = $FORM{'name'};
    my $tmp_username    = $FORM{'username'};
    my $tmp_displayname = $FORM{'displayname'};
    my $posted          = $FORM{'posted'};
    my $descr           = $FORM{'message'};

    $descr = clean1($descr);

    $filename =~ s/\s/_/gxsm;
    $filename =~ s/\'//gxsm;
    $filename =~ s/\./_/gxsm;
    $filename =~ s/\,/_/gxsm;
    $filename =~ s/\?/_/gxsm;
    $filename =~ s/\!/_/gxsm;
    $filename =~ s/\;/_/gxsm;
    $filename =~ s/\(/_/gxsm;
    $filename =~ s/\)/_/gxsm;
    $filename =~ s/\[/_/gxsm;
    $filename =~ s/\]/_/gxsm;
    $filename =~ s/\{/_/gxsm;
    $filename =~ s/\}/_/gxsm;
    $filename =~ s/:/_/gxsm;
    $filename =~ s/\//_/gxsm;
    $filename =~ s/\$/_/gxsm;
    $filename =~ s/\+/_/gxsm;
    $filename =~ s/\-/_/gxsm;
    $filename =~ s/\*/_/gxsm;
    $filename =~ s/\&/_/gxsm;
    $filename =~ s/\%/_/gxsm;
    $filename =~ s/\"/_/gxsm;
    $filename =~ s/\#/_/gxsm;
    $filename =~ s/\</_/gxsm;
    $filename =~ s/\>/_/gxsm;
    $filename =~ s/\@/_/gxsm;
    $filename =~ s/__/_/gxsm;

    if ( length($filename) > 25 ) { $filename = substr $filename, 0, 25; }
    if ( $title eq q{_} || $title eq q{} ) { fatal_error('quiz_noname'); }
    if ( $title eq q{|} ) { fatal_error('quiz_invalname'); }
    if ( $filename !~ /\A[0-9A-Za-z_]+\Z/sm ) { fatal_error('quiz_invalname'); }
    if ( $descr eq q{} ) { fatal_error('quiz_nodescription'); }
    if ( -e ("$vardir/Mods/$filename.quiz") ) {
        fatal_error('quiz_nameexsist');
    }

    $yymain = q~
        Teststring ~;

    our ($FILE);
    fopen( 'FILE', '>', "$vardir/Mods/$filename.quiz" );
    print {$FILE}
"$title\nblank.gif\n$tmp_username\n$tmp_displayname\n$descr\n0\n0\n0|0\n$FORM{'posted'}\n"
      or croak "$croak{'print'} FILE";
    fclose('FILE');

    write_log();
    $yysetlocation = qq~$scripturl?action=quizquestionadd;name=$filename~;
    redirectexit();
}

sub quizquestionadd {
    require "$vardir/Mods/quiz2.txt";
    my $quizname = $INFO{'name'};
    my $date2    = $date;
    our ($QUIZFILE);
    fopen( 'QUIZFILE', '<', "$vardir/Mods/$quizname.quiz" );
    my @quiz = <$QUIZFILE>;
    fclose('QUIZFILE');
    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    if ($ispublic) {
        fatal_error('quiz_noaddquestion');
    }

    if ($iamguest) {
        fatal_error('quiz_noadd_login');
    }

    if ( $username ne $quiz[2] && !$iamadmin ) {
        fatal_error('quiz_noaddquestion');
    }

    my $access = quizaccesscheck('add');

    if ( !$access ) {
        fatal_error('quiz_noaddquestion');
    }

    $yytitle .= qq~ $quiztxt{'28'} ~;

    $yynavigation =
qq~&rsaquo; <a href="$scripturl?action=quiz" class="nav">$quiztxt{'4'}</a> &rsaquo;
    <a href="$scripturl?action=quizdisplay;name=$quizname" class="nav">$quiz[0]</a> &rsaquo;
    $quiztxt{'28'}~;

    drawEditor($QuizMaxQuestChars);
    my $Quiztimelim = q{};

    if ( !$QuestionTimelimit ) { $QuestionTimelimit = 0; }
    if ($QuizSetTimelimit) {
        $Quiztimelim .= $myQuiztimelim_01;
        $Quiztimelim =~ s/\Q{yabb QuizMaxTimelimit}\E/$QuizMaxTimelimit/gxsm;
        $Quiztimelim =~ s/\Q{yabb QuestionTimelimit}\E/$QuestionTimelimit/gxsm;
    }
    else {
        $Quiztimelim .= $myQuiztimelim_02;
    }

    $yymain .= $myquizaddquest_01;
    $yymain =~ s/\Q{yabb quizname}\E/$quizname/gxsm;
    $yymain =~ s/\Q{yabb quiz0}\E/$quiz[0]/gxsm;
    $yymain =~ s/\Q{yabb editmain}\E/$editmain/gxsm;
    $yymain =~ s/\Q{yabb Quiztimelim}\E/$Quiztimelim/gxsm;

    template();
    exit;
}

sub quizquestionadd2 {

    require "$vardir/Mods/quiz2.txt";
    if ($iamguest) {
        fatal_error('quiz_noadd_login');
    }

    if ( !$QuizAddAllMembers && !$iamadmin ) {
        fatal_error('quiz_noadd');
    }

    my $quizname = $INFO{'name'};
    chomp $quizname;

    our ($QUIZFILE);
    fopen( 'QUIZFILE', '<', "$vardir/Mods/$quizname.quiz" );
    my @quiz = <$QUIZFILE>;
    fclose('QUIZFILE');

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }
    chomp @quiz;

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    if ($ispublic) {
        fatal_error('quiz_noadd');
    }

    if ( $username ne $quiz[2] && !$iamadmin ) {
        fatal_error('quiz_noadd');
    }

    ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    my $tmp_question  = $FORM{'message'};
    my $tmp_answer1   = $FORM{'answer1'};
    my $tmp_answer2   = $FORM{'answer2'};
    my $tmp_answer3   = $FORM{'answer3'};
    my $tmp_answer4   = $FORM{'answer4'};
    my $tmp_answer5   = $FORM{'answer5'};
    my $tmp_solution  = $FORM{'solution'};
    my $tmp_comment   = $FORM{'comment'};
    my $tmp_timelimit = $FORM{'QuestionTimelimit'};

    $tmp_question = clean1($tmp_question);
    $tmp_answer1  = clean1($tmp_answer1);
    $tmp_answer2  = clean1($tmp_answer2);
    $tmp_answer3  = clean1($tmp_answer3);
    $tmp_answer4  = clean1($tmp_answer4);
    $tmp_answer5  = clean1($tmp_answer5);
    $tmp_comment  = clean1($tmp_comment);

    if ( length($tmp_question) == 0 ) { fatal_error('quiz_noquestion'); }

    my $tmp_answernumber = 0;
    if ( length($tmp_answer1) > 0 ) { $tmp_answernumber++ }
    if ( length($tmp_answer2) > 0 ) { $tmp_answernumber++ }
    if ( length($tmp_answer3) > 0 ) { $tmp_answernumber++ }
    if ( length($tmp_answer4) > 0 ) { $tmp_answernumber++ }
    if ( length($tmp_answer5) > 0 ) { $tmp_answernumber++ }

    if    ( $tmp_answernumber == 0 ) { fatal_error('quiz_noanswer'); }
    elsif ( $tmp_answernumber == 1 ) { fatal_error('quiz_twoansvers'); }

    if ( length($tmp_solution) == 0 ) { fatal_error('quiz_noradiobutton'); }

    if ( length($tmp_answer1) == 0 && $tmp_solution == 1 ) {
        fatal_error('quiz_emptysolution');
    }
    if ( length($tmp_answer2) == 0 && $tmp_solution == 2 ) {
        fatal_error('quiz_emptysolution');
    }
    if ( length($tmp_answer3) == 0 && $tmp_solution == 3 ) {
        fatal_error('quiz_emptysolution');
    }
    if ( length($tmp_answer4) == 0 && $tmp_solution == 4 ) {
        fatal_error('quiz_emptysolution');
    }
    if ( length($tmp_answer5) == 0 && $tmp_solution == 5 ) {
        fatal_error('quiz_emptysolution');
    }

    if ( $tmp_timelimit =~ /\D/sm ) { fatal_error('quiz_timelimitnumb'); }
    if ( $tmp_timelimit > $QuizMaxTimelimit ) {
        $tmp_timelimit = $QuizMaxTimelimit;
    }

    $quizquestionnumber++;

    $quiz[7] = qq~$quizquestionnumber|$ispublic~;

    our ($FILE);
    fopen( 'FILE', '>', "$vardir/Mods/$quizname.quiz" );
    my $quizcount = @quiz;
    for my $i ( 0 .. ( $quizcount - 1 ) ) {
        print {$FILE} "$quiz[$i]\n" or croak "$croak{'print'} FILE";
    }
    print {$FILE}
"$tmp_question|$tmp_solution|$tmp_answer1|$tmp_answer2|$tmp_answer3|$tmp_answer4|$tmp_answer5|$tmp_comment|$tmp_timelimit\n"
      or croak "$croak{'print'} FILE";
    fclose('FILE');

    write_log();
    $yysetlocation = qq~$scripturl?action=quizdisplay;name=$quizname~;
    redirectexit();
    return;
}

sub quizquestion {

    require "$vardir/Mods/quiz2.txt";
    if ($iamguest) { fatal_error('quiz_loginorreg'); }

    my $quizname = $INFO{'name'};
    chomp $quizname;

    our ($QUIZFILE);
    fopen( 'QUIZFILE', '<', "$vardir/Mods/$quizname.quiz" );
    my @quiz = <$QUIZFILE>;
    fclose('QUIZFILE');

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    chomp @quiz;

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    my $questionnumber = 1;

    if ( -e ("$memberdir/$username.quiz") ) {
        our ($FILE);
        fopen( 'FILE', '<', "$memberdir/$username.quiz" );
        my @membquiz = <$FILE>;
        fclose('FILE');

        for my $i (@membquiz) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }

        my $membquizcount = @membquiz;
        for my $i ( 0 .. ( $membquizcount - 1 ) ) {
            my ( $tmp_quizname, $tmp_quizposition, $tmp_quizpoints ) =
              split /[|]/xsm, $membquiz[$i];
            if ( $tmp_quizname eq $quizname ) {
                $questionnumber = $tmp_quizposition;
                $questionnumber++;
            }
        }
    }

    if ( $questionnumber > $quizquestionnumber ) {
        fatal_error('quiz_solvedtakeanother');
    }

    my $quizcreatorname = $quiz[2];
    my $questionstrg    = $quiz[ $questionnumber + 8 ];
    my $imgquizhome =
      qq~<a href="$scripturl?action=quiz" class="imgcatbg">$quiztxt{'74'}</a>~;
    if ( $questionnumber > 1 ) {
        $imgquizhome =
qq~<a href="$scripturl?action=quiz" class="imgcatbg">$quiztxt{'73'}</a>~;
    }
    my (
        $question, $solution, $answer1,
        $answer2,  $answer3,  $answer4,
        $answer5,  $comment,  $QuestionTimelimit
    ) = split /[|]/xsm, $questionstrg;

    $question = clean1($question);
    $answer1  = clean1($answer1);
    $answer2  = clean1($answer2);
    $answer3  = clean1($answer3);
    $answer4  = clean1($answer4);
    $answer5  = clean1($answer5);
    $comment  = clean1($comment);

    # censor quiz answers and questions
    load_censor_list();
    foreach (@censored) {
        my ( $tmpa, $tmpb ) = @{$_};
        $question =~ s/\Q$tmpa\E/$tmpb/gism;
        $answer1 =~ s/\Q$tmpa\E/$tmpb/gism;
        $answer2 =~ s/\Q$tmpa\E/$tmpb/gism;
        $answer3 =~ s/\Q$tmpa\E/$tmpb/gism;
        $answer4 =~ s/\Q$tmpa\E/$tmpb/gism;
        $answer5 =~ s/\Q$tmpa\E/$tmpb/gism;
        $comment =~ s/\Q$tmpa\E/$tmpb/gism;
    }
    my @questlist =
      ( "$answer1", "$answer2", "$answer3", "$answer4", "$answer5" );
    if ($enable_ubbc) {
        enable_yabbc();
        $question = do_ubbc( $question, q{}, $quizcreatorname );
        for my $i (@questlist) {
            $i = do_ubbc( $i, q{}, $quizcreatorname );
        }
        $comment = do_ubbc( $comment, q{}, $quizcreatorname );
    }

    $yynavigation =
qq~&rsaquo; <a href="$scripturl?action=quiz" class="nav">$quiztxt{'4'}</a> &rsaquo;
    <a href="$scripturl?action=quizdisplay;name=$quizname" class="nav">$quiz[0]</a> &rsaquo;
    $quiztxt{'39'} $questionnumber ~;

    $yytitle .= qq~ $quiz[0] $quiztxt{'39'} $questionnumber~;

    my $myquiztime = q{};
    if ( $QuestionTimelimit > 0 && $QuizSetTimelimit ) {
        $myquiztime = $myquiztime;
        $myquiztime =~ s/\Q{yabb QuestionTimelimit}\E/$QuestionTimelimit/gxsm;
        $myquiztime =~ s/\Q{yabb questionnumber}\E/$questionnumber/gxsm;
    }

    my $num       = 1;
    my $qanswer   = q{};
    my $questmain = q{};
    for my $i (@questlist) {
        if ( length($i) > 0 ) {
            $qanswer = $myquizanswer;
            $qanswer =~ s/\Q{yabb answer}\E/$i/gxsm;
            $qanswer =~ s/\Q{yabb answern}\E/$num/gxsm;
            $questmain .= $qanswer;
            $num++;
        }
    }
    my $myqbutton = $quiztxt{'53'};
    if ( $questionnumber < $quizquestionnumber ) {
        $myqbutton = $quiztxt{'52'};
    }
    $yymain .= $myquiz01;
    $yymain =~ s/\Q{yabb quizname}\E/$quizname/gxsm;
    $yymain =~ s/\Q{yabb questionnumber}\E/$questionnumber/gxsm;
    $yymain =~ s/\Q{yabb quiz0}\E/$quiz[0]/gxsm;
    $yymain =~ s/\Q{yabb question}\E/$question/gxsm;
    $yymain =~ s/\Q{yabb myquiztime}\E/$myquiztime/gxsm;
    $yymain =~ s/\Q{yabb questmain}\E/$questmain/gxsm;
    $yymain =~ s/\Q{yabb myqbutton}\E/$myqbutton/gxsm;
    $yymain =~ s/\Q{yabb imgquizhome}\E/$imgquizhome/gxsm;

    template();
    exit;
}

sub quizquestion2 {

    if ($iamguest) { fatal_error('quiz_loginorreg'); }

    my $quizname = $INFO{'name'};
    chomp $quizname;

    our ($QUIZFILE);
    fopen( 'QUIZFILE', '<', "$vardir/Mods/$quizname.quiz" );
    my @quiz = <$QUIZFILE>;
    fclose('QUIZFILE');

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }
    chomp @quiz;
    my ( $questionnumber, $answer );
    if ( $INFO{'questionnumber'} ) {
        $questionnumber = $INFO{'questionnumber'};
        $answer         = 0;
    }
    else {
        $questionnumber = $FORM{'questionnumber'};
        $answer         = $FORM{'answer'};
    }

    if ( length($answer) == 0 ) { fatal_error('quiz_noanswerselected'); }

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    my $questionstrg = $quiz[ $questionnumber + 8 ];
    my (
        $tmp_question, $tmp_solution, $tmp_answer1, $tmp_answer2,
        $tmp_answer3,  $tmp_answer4,  $tmp_answer5, $tmp_comment
    ) = split /[|]/xsm, $questionstrg;
    my $tmp_newpoints = 0;
    if   ( $answer == $tmp_solution ) { $tmp_newpoints = 1; }
    else                              { $tmp_newpoints = 0; }

    my $yourpoints = $tmp_newpoints;
    my $isCheat    = 0;

    if ( !-e ("$memberdir/$username.quiz") ) {
        our ($FILE);
        fopen( 'FILE', '>', "$memberdir/$username.quiz" );
        print {$FILE} "$quizname|1|$tmp_newpoints\n"
          or croak "$croak{'print'} FILE";
        fclose('FILE');
    }
    else {
        our ($FILE);
        fopen( 'FILE', '<', "$memberdir/$username.quiz" );
        my @membquiz = <$FILE>;
        fclose('FILE');

        for my $i (@membquiz) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }

        chomp @membquiz;
        my $membquizcount = @membquiz;

        fopen( 'FILE', '>', "$memberdir/$username.quiz" );
        for my $i ( 0 .. ( $membquizcount - 1 ) ) {
            my ( $tmp_quizname, $tmp_quizposition, $tmp_quizpoints ) =
              split /[|]/xsm, $membquiz[$i];
            if ( $tmp_quizname ne $quizname ) {
                print {$FILE}
                  "$tmp_quizname|$tmp_quizposition|$tmp_quizpoints\n"
                  or croak "$croak{'print'} FILE";
            }
            else {
                if ( $questionnumber <= $tmp_quizposition ) {
                    $isCheat = 1;
                    print {$FILE}
                      "$tmp_quizname|$tmp_quizposition|$tmp_quizpoints"
                      or croak "$croak{'print'} FILE";
                }
                $yourpoints = $tmp_quizpoints + $tmp_newpoints;
            }
        }
        if ( !$isCheat ) {
            print {$FILE} "$quizname|$questionnumber|$yourpoints\n"
              or croak "$croak{'print'} FILE";
        }
        fclose('FILE');
    }
    my $tmp_answertxt   = q{};
    my $tmp_solutiontxt = q{};
    if ( !$isCheat ) {
        if    ( $answer == 1 ) { $tmp_answertxt = $tmp_answer1; }
        elsif ( $answer == 2 ) { $tmp_answertxt = $tmp_answer2; }
        elsif ( $answer == 3 ) { $tmp_answertxt = $tmp_answer3; }
        elsif ( $answer == 4 ) { $tmp_answertxt = $tmp_answer4; }
        elsif ( $answer == 5 ) { $tmp_answertxt = $tmp_answer5; }
        else                   { $tmp_answertxt = $quiztxt{'102'}; }

        if    ( $tmp_solution == 1 ) { $tmp_solutiontxt = $tmp_answer1; }
        elsif ( $tmp_solution == 2 ) { $tmp_solutiontxt = $tmp_answer2; }
        elsif ( $tmp_solution == 3 ) { $tmp_solutiontxt = $tmp_answer3; }
        elsif ( $tmp_solution == 4 ) { $tmp_solutiontxt = $tmp_answer4; }
        else                         { $tmp_solutiontxt = $tmp_answer5; }

        our ($QUIZLOGFILE);
        fopen( 'QUIZLOGFILE', '>>', "$memberdir/$username.quizlog" );
        print {$QUIZLOGFILE}
"$quizname|$tmp_question|$tmp_answertxt|$tmp_solutiontxt|$tmp_comment\n"
          or croak "$croak{'print'} FILE";
        fclose('QUIZLOGFILE');

        if ( $questionnumber == 1 ) {
            our ($FILE);
            fopen( 'FILE', '>>', "$vardir/Mods/$quizname.quizresult" );
            print {$FILE} "$username||\n" or croak "$croak{'print'} FILE";
            fclose('FILE');
        }
    }

    if ( $quizquestionnumber == $questionnumber ) {
        quizresult();
    }
    else {
        if   ($isCheat) { fatal_error('quiz_cheating'); }
        else            { $questionnumber++; }
        quizquestion();
    }
    return;
}

sub quizresult {

    require "$vardir/Mods/quiz2.txt";

    my $quizname = $INFO{'name'};

    if ($iamguest) { fatal_error('quiz_loginorreg'); }
    if ( !-e ("$memberdir/$username.quiz") ) { fatal_error('quiz_notsolved'); }

    our ($FILE);
    fopen( 'FILE', '<', "$memberdir/$username.quiz" );
    my @membquiz = <$FILE>;
    fclose('FILE');

    for my $i (@membquiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    my $membquizcount = @membquiz;
    my $yourpoints    = 0;

    for my $i ( 0 .. ( $membquizcount - 1 ) ) {
        my ( $tmp_quizname, $tmp_quizposition, $tmp_quizpoints ) =
          split /[|]/xsm, $membquiz[$i];
        if ( $tmp_quizname eq $quizname ) { $yourpoints = $tmp_quizpoints; }
    }

    if ( $yourpoints == -1 ) { fatal_error('quiz_notsolved'); }

    our ($QUIZFILE);
    fopen( 'QUIZFILE', '<', "$vardir/Mods/$quizname.quiz" );
    my @quiz = <$QUIZFILE>;
    fclose('QUIZFILE');

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    # prevent cheat
    # Load Quiz Highscore
    my $isCheat = 0;
    fopen( 'FILE', '<', "$vardir/Mods/$quizname.quizresult" );
    my @quizscorelist = <$FILE>;
    fclose('FILE');
    chomp @quizscorelist;
    my $quizscores = @quizscorelist;
    for my $i ( 0 .. ( $quizscores - 1 ) ) {
        my ( $tmp_username, $tmp_score, $tmp_date ) = split /[|]/xsm,
          $quizscorelist[$i];
        if ( $tmp_username eq $username && $tmp_date ) { $isCheat = 1; }
    }

    # end prevent cheat

    if ( $quizquestionnumber == 0 ) { fatal_error('quiz_havenoquestion'); }

    my $yourpercent = 100 * $yourpoints / $quizquestionnumber;
    $quiz[6] = ( $quiz[5] * $quiz[6] + $yourpercent ) / ( $quiz[5] + 1 );
    $quiz[5]++;

    if ( !$isCheat ) {
        fopen( 'FILE', '>', "$vardir/Mods/$quizname.quiz" );
        my $quizcount = @quiz;
        for my $i ( 0 .. ( $quizcount - 1 ) ) {
            print {$FILE} "$quiz[$i]\n" or croak "$croak{'print'} FILE";
        }
    }

    my $quizdisplayname  = $quiz[0];
    my $quizaverage      = $quiz[6];
    my $quiztimes        = $quiz[5];
    my $yourpercentwidth = int( 3 * $yourpercent + 0.5 );
    $yourpercent = int( 10 * $yourpercent + 0.5 ) * 0.1;    # round
    my $quizaveragewidth  = int( 3 * $quizaverage + 0.5 );
    my $quizpercent       = int( 10 * $quizaverage + 0.5 ) * 0.1;       # round
    my $quizaveragepoints = $quizaverage * $quizquestionnumber / 100;
    $quizaveragepoints = 0.1 * int( 10 * $quizaveragepoints + 0.5 );

    if ( length($QuizBar) == 0 ) {
        $QuizBar = "$modimgurl/quiz/QuizBar.gif";
    }

    if ( !$isCheat ) {
        our ($RESFILE);
        fopen( 'RESFILE', '<', "$vardir/Mods/$quizname.quizresult" );
        my @quizres = <$RESFILE>;
        fclose('RESFILE');
        my $quizrescount = @quizres;
        for my $i (@quizres) {
            $i =~ tr/\r//d;
            $i =~ tr/\n//d;
        }
        chomp @quizres;

        fopen( 'FILE', '>', "$vardir/Mods/$quizname.quizresult" );
        for my $i ( 0 .. ( $quizrescount - 1 ) ) {
            my ( $tmpusername, $tmpyourpercent, $tmpdate ) = split /[|]/xsm,
              $quizres[$i];
            if ( $tmpusername ne $username ) {
                print {$FILE} "$quizres[$i]\n" or croak "$croak{'print'} FILE";
            }
        }
        print {$FILE} "$username|$yourpercent|$date\n"
          or croak "$croak{'print'} FILE";
        fclose('FILE');
    }

    my $imgquizhome =
      qq~<a href="$scripturl?action=quiz">$img{'imgquizhome'}</a>~;

    $yytitle .= qq~ $quizdisplayname $quiztxt{'61'} ~;

    $yynavigation =
qq~&rsaquo; <a href="$scripturl?action=quiz" class="nav">$quiztxt{'4'}</a> &rsaquo;
    <a href="$scripturl?action=quizdisplay;name=$quizname" class="nav">$quizdisplayname</a> &rsaquo;
    $quiztxt{'61'} ~;

    our ($QUIZLOGFILE);
    fopen( 'QUIZLOGFILE', '<', "$memberdir/$username.quizlog" );
    my @quizlog = <$QUIZLOGFILE>;
    fclose('QUIZLOGFILE');

    for my $i (@quizlog) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    chomp @quizlog;
    my $logcount = @quizlog;

    my $quizanswers = q{};
    for my $i ( 0 .. ( $logcount - 1 ) ) {
        my (
            $log_quizname,    $log_question, $log_answertxt,
            $log_solutiontxt, $log_commenttxt
        ) = split /[|]/xsm, $quizlog[$i];
        if ( $quizname eq $log_quizname ) {
            my $log_wrongcorrect = $quiztxt{'79'};
            if ( $log_answertxt eq $log_solutiontxt ) {
                $log_wrongcorrect = $quiztxt{'78'};
            }
            else { $log_wrongcorrect = $quiztxt{'79'} }

            # no html code in answers and questions
            $log_question    = clean1($log_question);
            $log_answertxt   = clean1($log_answertxt);
            $log_solutiontxt = clean1($log_solutiontxt);
            $log_commenttxt  = clean1($log_commenttxt);

            # censor quiz answers and questions
            load_censor_list();
            foreach (@censored) {
                my ( $tmpa, $tmpb ) = @{$_};
                $log_question =~ s/\Q$tmpa\E/$tmpb/gism;
                $log_answertxt =~ s/\Q$tmpa\E/$tmpb/gism;
                $log_solutiontxt =~ s/\Q$tmpa\E/$tmpb/gism;
                $log_commenttxt =~ s/\Q$tmpa\E/$tmpb/gism;
            }

            # do YaBBC  on the quiz answers and questions
            if ($enable_ubbc) {
                enable_yabbc();
                $log_question = do_ubbc( $log_question, q{}, $quizcreatorname );
                $log_answertxt =
                  do_ubbc( $log_answertxt, q{}, $quizcreatorname );
                $log_solutiontxt =
                  do_ubbc( $log_solutiontxt, q{}, $quizcreatorname );
                $log_commenttxt =
                  do_ubbc( $log_commenttxt, q{}, $quizcreatorname );
            }

            $quizanswers .= $myquizresult_02;
            $quizanswers =~ s/\Q{yabb log_question}\E/$log_question/gxsm;
            $quizanswers =~ s/\Q{yabb log_answertxt}\E/$log_answertxt/gxsm;
            $quizanswers =~ s/\Q{yabb log_solutiontxt}\E/$log_solutiontxt/gxsm;
            $quizanswers =~
              s/\Q{yabb log_wrongcorrect}\E/$log_wrongcorrect/gxsm;
            $quizanswers =~ s/\Q{yabb log_commenttxt}\E/$log_commenttxt/gxsm;
        }
    }
    $yymain .= $myquizresult_01;
    $yymain =~ s/\Q{yabb quizdisplayname}\E/$quizdisplayname/gxsm;
    $yymain =~ s/\Q{yabb yourpoints}\E/$yourpoints/gxsm;
    $yymain =~ s/\Q{yabb quizquestionnumber}\E/$quizquestionnumber/gxsm;
    $yymain =~ s/\Q{yabb yourpercent}\E/$yourpercent/gxsm;
    $yymain =~ s/\Q{yabb QuizBar}\E/$QuizBar/gxsm;
    $yymain =~ s/\Q{yabb yourpercentwidth}\E/$yourpercentwidth/gxsm;
    $yymain =~ s/\Q{yabb quizaveragepoints}\E/$quizaveragepoints/gxsm;
    $yymain =~ s/\Q{yabb quizpercent}\E/$quizpercent/gxsm;
    $yymain =~ s/\Q{yabb quizaveragewidth}\E/$quizaveragewidth/gxsm;
    $yymain =~ s/\Q{yabb imgquizhome}\E/$imgquizhome/gxsm;
    $yymain =~ s/\Q{yabb quizanswers}\E/$quizanswers/gxsm;

    # Load Quiz Highscore
    fopen( 'FILE', '<', "$vardir/Mods/$quizname.quizresult" );
    @quizscorelist = <$FILE>;
    fclose('FILE');

    chomp @quizscorelist;
    $quizscores = @quizscorelist;
    my $i                = 0;
    my $x                = 0;
    my @tmpquizscorelist = ();
    while ( $i < $quizscores ) {
        my ( $tmp_username, $tmp_score, $tmp_date ) = split /[|]/xsm,
          $quizscorelist[$i];
        chomp $tmp_date;
        if ( !$tmp_date ) { $i++; next; }
        if ( $tmp_date =~
            m/(\d{2})\/(\d{2})\/(\d{2,4}).*?(\d{2})\:(\d{2})\:(\d{2})/ism )
        {
            $tmp_date = stringtotime($tmp_date);
        }
        my $date2    = $date;
        my $date1    = $tmp_date;
        my $days_reg = calcdtdiff( $date1, $date2 );

        #$days_reg = $result;
        $tmpquizscorelist[$x] =
          qq~$tmp_username|$tmp_score|$tmp_date|$days_reg~;
        $x++;
        $i++;
    }

    $quizscores = @tmpquizscorelist;

    # Sort quizscorelist by highscore

    my @sortscorelist =
      map { $_->[0] }
      sort { ( $b->[2] ) <=> ( $a->[2] ) || uc( $a->[0] ) cmp uc( $b->[0] ) }
      map { [ $_, ( split /[|]/xsm )[ 0 .. 2 ] ] } (@tmpquizscorelist);

    my $highscorelength = $QuizHighScoreLength;

    if ( $INFO{'sort'} && $INFO{'sort'} eq 'high' ) {
        $highscorelength = $quizscores;
    }
    if ( $highscorelength > $quizscores ) { $highscorelength = $quizscores; }
    if ( $INFO{'sort'} && $INFO{'sort'} eq 'latest' ) { $highscorelength = 0; }

    if ( $highscorelength > 0 ) {
        my $quizhi = q{};
        my $xxmain .= qq~
    <div style="float: left; width: 100%; margin-bottom: 8px;">
        <div style="float: left; width: 49%;">
        <table class="pad_4px cs_thin">
        <tr>
            <td colspan="3" class="titlebg center">
                $quiztxt{'19'}
            </td>
        </tr><tr>
            <td class="catbg">
                $quiztxt{'14'}
            </td>
            <td class="catbg">
                $quiztxt{'15'}
            </td>
            <td class="catbg">
                $quiztxt{'16'}
            </td>
        </tr>~;
    }
    my $quizhi = q{};
    for my $i ( 0 .. ( $highscorelength - 1 ) ) {
        my ( $tmp_username, $highscore, $tmp_date, $days_reg ) = split /[|]/xsm,
          $sortscorelist[$i];
        $tmp_date = timeformat($tmp_date);

        load_user($tmp_username);
        my $tmp_userprofile = $tmp_username;
        {
            no strict qw(refs);
            if ( ${ $uid . $tmp_username }{'realname'} ) {
                $tmp_userprofile = $link{$tmp_username};
            }
            else {
                $tmp_userprofile = $tmp_username;
            }
        }
        $quizhi .= $myquizdisplay_07;
        $quizhi =~ s/\Q{yabb tmp_userprofile}\E/$tmp_userprofile/gxsm;
        $quizhi =~ s/\Q{yabb highscore}\E/$highscore/gxsm;
        $quizhi =~ s/\Q{yabb tmp_date}\E/$tmp_date/gxsm;
    }

    if ( $highscorelength < $quizscores && $highscorelength > 0 ) {
        $quizhi .= $myquizdisplay_08;
        $quizhi =~ s/\Q{yabb quizname}\E/$quizname/gxsm;
    }

    $yymain .= $myquizdisplay_06;
    $yymain =~ s/\Q{yabb quizhi}\E/$quizhi/gxsm;

    # Sort quizscorelist by date

    @sortscorelist =
      map { $_->[0] }
      sort { ( $a->[4] ) <=> ( $b->[4] ) || uc( $a->[0] ) cmp uc( $b->[0] ) }
      map { [ $_, ( split /[|]/xsm )[ 0 .. 4 ] ] } (@tmpquizscorelist);

    $highscorelength = $QuizHighScoreLength;
    if ( $INFO{'sort'} && $INFO{'sort'} eq 'latest' ) {
        $highscorelength = $quizscores;
    }
    if ( $highscorelength > $quizscores ) { $highscorelength = $quizscores; }
    if ( $INFO{'sort'} && $INFO{'sort'} eq 'high' ) { $highscorelength = 0; }

    if ( $highscorelength > 0 ) {
        my $quizhi2 = q{};
        for my $i ( 0 .. ( $highscorelength - 1 ) ) {
            my ( $tmp_username, $highscore, $tmpdate, $reg_days ) =
              split /[|]/xsm, $sortscorelist[$i];
            $tmpdate = timeformat($tmpdate);

            load_user($tmp_username);
            my $tmp_userprofile = $link{$tmp_username};
            $quizhi2 .= $myquizdisplay_07;
            $quizhi2 =~ s/\Q{yabb tmp_userprofile}\E/$tmp_userprofile/gxsm;
            $quizhi2 =~ s/\Q{yabb highscore}\E/$highscore/gxsm;
            $quizhi2 =~ s/\Q{yabb tmp_date}\E/$tmpdate/gxsm;
        }

        if ( $highscorelength < $quizscores ) {
            $quizhi2 .= $myquizdisplay_08;
            $quizhi2 =~ s/\Q{yabb quizname}\E/$quizname/gxsm;
        }
        $yymain .= $myquizdisplay_09;
        $yymain =~ s/\Q{yabb quizhi2}\E/$quizhi2/gxsm;
    }

    template();
    exit;
}

sub quizquestionmodify {

    if ($iamguest) {
        fatal_error( $error_txt{'no_access'} );
    }

    require "$vardir/Mods/quiz2.txt";

    my $quizname = $INFO{'name'};
    my $date2    = $date;

    our ($QUIZFILE);
    fopen( 'QUIZFILE', '<', "$vardir/Mods/$quizname.quiz" );
    my @quiz = <$QUIZFILE>;
    fclose('QUIZFILE');

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }
    chomp @quiz;

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    my $quizcreatorname = $quiz[2];

    my $access = quizaccesscheck('mod');

    if ($ispublic) {
        fatal_error('quiz_noaddquestion');
    }

    my $quizcount = @quiz;

    if ( !$access ) {
        fatal_error('quiz_nomodify');
    }

    $yytitle .= qq~ $quiztxt{'27'} ~;

    $yynavigation =
qq~&rsaquo; <a href="$scripturl?action=quiz" class="nav">$quiztxt{'4'}</a> &rsaquo;
    <a href="$scripturl?action=quizdisplay;name=$quizname" class="nav">$quiz[0]</a> &rsaquo;
    $quiztxt{'27'} ~;

    $quiz[4] = clean1( $quiz[4] );

    $yymain .= $myQuizmodify_01;
    $yymain =~ s/\Q{yabb quizname}\E/$quizname/gxsm;
    $yymain =~ s/\Q{yabb quiz0}\E/$quiz[0]/gxsm;
    $yymain =~ s/\Q{yabb quiz4}\E/$quiz[4]/gxsm;

    for my $i ( 9 .. ( $quizcount - 1 ) ) {
        my (
            $question, $solution, $answer1,
            $answer2,  $answer3,  $answer4,
            $answer5,  $comment,  $QuestionTimelimit
        ) = split /[|]/xsm, $quiz[$i];

        my $quest_num = $i - 8;
        my $solution1 = q{};
        my $solution2 = q{};
        my $solution3 = q{};
        my $solution4 = q{};
        my $solution5 = q{};

        if    ( $solution == 1 ) { $solution1 = q~checked="checked"~; }
        elsif ( $solution == 2 ) { $solution2 = q~checked="checked"~; }
        elsif ( $solution == 3 ) { $solution3 = q~checked="checked"~; }
        elsif ( $solution == 4 ) { $solution4 = q~checked="checked"~; }
        else                     { $solution5 = q~checked="checked"~; }

        $question = clean1($question);
        $answer1  = clean1($answer1);
        $answer2  = clean1($answer2);
        $answer3  = clean1($answer3);
        $answer4  = clean1($answer4);
        $answer5  = clean1($answer5);
        $comment  = clean1($comment);

        $yymain .= $myQuizmodify_02;
        $yymain =~ s/\Q{yabb quizname}\E/$quizname/gxsm;
        $yymain =~ s/\Q{yabb i}\E/$i/gxsm;
        $yymain =~ s/\Q{yabb question}\E/$question/gxsm;
        $yymain =~ s/\Q{yabb solution1}\E/$solution1/gxsm;
        $yymain =~ s/\Q{yabb answer1}\E/$answer1/gxsm;
        $yymain =~ s/\Q{yabb solution2}\E/$solution2/gxsm;
        $yymain =~ s/\Q{yabb answer2}\E/$answer2/gxsm;
        $yymain =~ s/\Q{yabb solution3}\E/$solution3/gxsm;
        $yymain =~ s/\Q{yabb answer3}\E/$answer3/gxsm;
        $yymain =~ s/\Q{yabb solution4}\E/$solution4/gxsm;
        $yymain =~ s/\Q{yabb answer4}\E/$answer4/gxsm;
        $yymain =~ s/\Q{yabb solution5}\E/$solution5/gxsm;
        $yymain =~ s/\Q{yabb answer5}\E/$answer5/gxsm;
        $yymain =~ s/\Q{yabb comment}\E/$comment/gxsm;

        if ( !$QuestionTimelimit ) { $QuestionTimelimit = 0; }
        my $Quiztimelim = q{};
        if ($QuizSetTimelimit) {
            $Quiztimelim .= $myQuiztimelim_01;
            $Quiztimelim =~
              s/\Q{yabb QuizMaxTimelimit}\E/$QuizMaxTimelimit/gxsm;
            $Quiztimelim =~
              s/\Q{yabb QuestionTimelimit}\E/$QuestionTimelimit/gxsm;
        }
        else {
            $Quiztimelim .= $myQuiztimelim_02;
        }
        $yymain =~ s/\Q{yabb Quiztimelim}\E/$Quiztimelim/gxsm;
    }

    template();
    exit;
}

sub quizquestionmodify2 {

    require "$vardir/Mods/quiz2.txt";
    my $quizname = $INFO{'name'};
    my $date2    = $date;

    our ($QUIZFILE);
    fopen( 'QUIZFILE', '<', "$vardir/Mods/$quizname.quiz" );
    my @quiz = <$QUIZFILE>;
    fclose('QUIZFILE');

    for my $i (@quiz) {
        $i =~ tr/\r//d;
        $i =~ tr/\n//d;
    }

    chomp @quiz;
    my $quizcount = @quiz;
    my $num       = $FORM{'num'};

    my ( $quizquestionnumber, $ispublic ) = split /[|]/xsm, $quiz[7];

    my $quizcreatorname = $quiz[2];

    my $access = quizaccesscheck('mod');
    my (
        $question, $answer1,  $answer2, $answer3, $answer4,
        $answer5,  $solution, $comment, $timelimit
    );

    if ($ispublic) {
        fatal_error('quiz_noaddquestion');
    }

    if ($iamguest) {
        fatal_error( $error_txt{'no_access'} );
    }

    if ( !$access ) {
        fatal_error('quiz_nomodify');
    }

    if ( $num == 4 ) {
        $quiz[4] = $FORM{'message'};
        $quiz[4] = clean1( $quiz[4] );
    }
    else {
        $question  = $FORM{'message'};
        $answer1   = $FORM{'answer1'};
        $answer2   = $FORM{'answer2'};
        $answer3   = $FORM{'answer3'};
        $answer4   = $FORM{'answer4'};
        $answer5   = $FORM{'answer5'};
        $solution  = $FORM{'solution'};
        $comment   = $FORM{'comment'};
        $timelimit = $FORM{'QuestionTimelimit'};

        $question = clean1($question);
        $answer1  = clean1($answer1);
        $answer2  = clean1($answer2);
        $answer3  = clean1($answer3);
        $answer4  = clean1($answer4);
        $answer5  = clean1($answer5);
        $comment  = clean1($comment);

        if ( length($question) == 0 ) { fatal_error('quiz_noquestion'); }
        if ( length($answer1) == 0 && $solution == 1 ) {
            fatal_error('quiz_emptysolution');
        }
        if ( length($answer2) == 0 && $solution == 2 ) {
            fatal_error('quiz_emptysolution');
        }
        if ( length($answer3) == 0 && $solution == 3 ) {
            fatal_error('quiz_emptysolution');
        }
        if ( length($answer4) == 0 && $solution == 4 ) {
            fatal_error('quiz_emptysolution');
        }
        if ( length($answer5) == 0 && $solution == 5 ) {
            fatal_error('quiz_emptysolution');
        }
        if ( $timelimit =~ /\D/sm ) { fatal_error('quiz_timelimitnumb'); }
        if ( $timelimit > $QuizMaxTimelimit ) {
            $timelimit = $QuizMaxTimelimit;
        }
        $quiz[$num] =
"$question|$solution|$answer1|$answer2|$answer3|$answer4|$answer5|$comment|$timelimit";
    }

    our ($FILE);
    fopen( 'FILE', '>', "$vardir/Mods/$quizname.quiz" );
    for my $i ( 0 .. ( $quizcount - 1 ) ) {
        print {$FILE} "$quiz[$i]\n" or croak "$croak{'print'} FILE";
    }
    fclose('FILE');

    write_log();
    $yysetlocation = qq~$scripturl?action=quizdisplay;name=$quizname~;
    redirectexit();
    return;
}

sub quizaccesscheck {
    my ($whatcheck) = @_;
    if ($iamguest) { return 0; }

    require "$vardir/Mods/quiz2.txt";

    my @quizaccess = ();
    if ( $whatcheck eq 'add' ) {
        @quizaccess = @QuizAddGroups;
    }
    elsif ( $whatcheck eq 'mod' ) {
        if ( $quizcreatorname && $username ne $quizcreatorname && !$iamadmin ) {
            return 0;
        }
        @quizaccess = @QuizModGroups;
    }
    elsif ( $whatcheck eq 'del' ) {
        if ( $quizcreatorname && $username ne $quizcreatorname && !$iamadmin ) {
            return 0;
        }
        @quizaccess = @QuizDelGroups;
    }

    if ($iamadmin) { return 1; }

    my $access = 0;
    my (%memberaddgroup);
    if ( !exists $memberunfo{$username} ) { load_user($username); }
    {
        no strict qw(refs);
        $memberaddgroup{$username} = ${ $uid . $username }{'addgroups'} || q{};
    }
    my $memberinform = $memberunfo{$username};
    for my $element (@quizaccess) {
        chomp $element;
        if ( $element eq $memberinform ) { $access = 1; }
        if ( $memberaddgroup{$username} ) {
            $memberaddgroup{$username} =~ s/\,\s /\,/gxsm;
            for
              my $memberaddgroups ( split /\,/xsm, $memberaddgroup{$username} )
            {
                chomp $memberaddgroups;
                if ( $element eq $memberaddgroups ) { $access = 1; last; }
            }
        }
    }
    return $access;
}

sub drawEditor {
    my ($maxchars) = @_;
    our $max_messlen = $maxchars;
    require Sources::ContextHelp;
    require Sources::PostBox;
    no strict qw(refs);
    my $displayname = ${ $uid . $username }{'realname'};
    $ctmain = context_script( 'post', $displayname );
    $editmain .= $ctmain;
    my $my_ubbc_yes = q{};

    if ( $enable_ubbc && $showyabbcbutt ) {
        $my_ubbc_yes .= qq~
            <div class="style_ubbc_box">~;
        $my_ubbc_yes .= postbox();
        $my_ubbc_yes .= q~</div>~;
    }
    $editmain .= $my_ubbc_yes;
    $editmain .= postbox2();
    $editmain .= postbox3();

    $editmain .= qq~
<script type="text/javascript">
var noalert = true, gralert = false, rdalert = false, clalert = false;
var cntsec = 0;

function tick() {
  cntsec++;
  calcCharLeft();
  var timerID = setTimeout("tick()",1000);
}

function calcCharLeft() {
  var clipped = false;
  var maxLength = $maxchars;
  if (document.postmodify.message.value.length > maxLength) {
    document.postmodify.message.value = document.postmodify.message.value.substring(0,maxLength);
    var charleft = 0;
    clipped = true;
  } else {
    charleft = maxLength - document.postmodify.message.value.length;
  }
  document.postmodify.msgCL.value = charleft
  if (charleft >= 100 && noalert) { noalert = false; gralert = true; rdalert = true; clalert = true; document.images.chrwarn.src="$defaultimagesdir/green1.gif"; }
  if (charleft < 100 && charleft >= 50 && gralert) { noalert = true; gralert = false; rdalert = true; clalert = true; document.images.chrwarn.src="$defaultimagesdir/green0.gif"; }
  if (charleft < 50 && charleft > 0 && rdalert) { noalert = true; gralert = true; rdalert = false; clalert = true; document.images.chrwarn.src="$defaultimagesdir/red0.gif" }
  if (charleft == 0 && clalert) { noalert = true; gralert = true; rdalert = true; clalert = false; document.images.chrwarn.src="$defaultimagesdir/red1.gif"; }
  return clipped;
}
tick();
</script>~;

    return $editmain;
}

sub clean1 {
    my ($tmp) = @_;
    $tmp =~ s/<br>/\n/gxsm;
    $tmp =~ s/<br\s \/>/\n/gxsm;
    $tmp =~ s/</&lt;/gxsm;
    $tmp =~ s/>/&gt;/gxsm;
    $tmp =~ s/\n/<br \/>/gxsm;
    return $tmp;
}

1;
